
;CYLINDER.LSP v1.0
;
;There are no restrictions on the variables.
;However the "Resolution" variable should be kept to whole
;integers.  Suggested Resolution is 10.
;
;Because of the extensive use of lines the HIDE command
;will not produce the desired results.  Later versions
;will correct for this.
;
;For the latest version send  $5.00(US) to:
;
;                 Kevin Reardon
;                 536 41 St. #27
;                 Oakland, CA   94609
;
;
(DEFUN C:CYLINDER ()
   (SETQ P1 (GETPOINT "First point: "))
   (SETQ P2 (GETPOINT "Second point: "))
   (SETQ RAD (GETDIST P1 "Radius: "))
   (SETQ RES (GETREAL "Resolution: "))
   (SETQ A (- (ANGLE P1 P2) 1.570796))
   (SETQ B (+ (ANGLE P1 P2) 1.570796))
   (SETQ EE (GETVAR "ELEVATION"))
   (SETQ C 0)
   (WHILE (< C (1+ RES))
      (SETQ T (* (/ C RES) 1.570796))
      (SETQ ELE (* RAD (SIN T)))
      (SETVAR "ELEVATION" (+ EE ELE))
      (SETQ X (* RAD (COS T)))
      (SETQ P1A (POLAR P1 A X))
      (SETQ P2A (POLAR P2 A X))
      (SETQ P1B (POLAR P1 B X))
      (SETQ P2B (POLAR P2 B X))
      (COMMAND "LINE" P1A P2A)
      (COMMAND)
      (COMMAND "LINE" P1B P2B)
      (COMMAND)
      (SETVAR "ELEVATION" (- EE ELE))
      (COMMAND "LINE" P1A P2A)
      (COMMAND)
      (COMMAND "LINE" P1B P2B)
      (COMMAND)
      (SETQ C (1+ C))
         )
   (SETVAR "ELEVATION" EE)
   (COMMAND "REDRAW")
 )MAND "LINE" P1B P2B)
      (COMMAND)
      (SETQ C (1+ C))
         )
   (SETVAR "ELEVATION" EE)
   (COMMAND "REDRA