(defun C:FILTER()
(setvar "cmdecho" 0)
(setq entity nil block nil ltype nil style nil layer nil elev nil
      thik nil color nil attf nil fltrlist nil)
(Defun Tsz (/ A B C D E F)
  (Setvar "Cmdecho" 0)
  (Setq C (Getreal "\nEnter new text size: "))
  (Setq A (ssget "X" fltrlist))
  (Setq B (Sslength A))
  (Initget 7)
  (While
    (> B 0)
      (Setq B (1- B))
      (Setq D (Ssname A B))
      (Setq D (Entget D))
      (Setq E (Assoc 40 D))
      (Setq F (Cons 40 C))
      (Entmod (Setq D (Subst F E D)))
  )
  (Setq A nil)
)

;Builds selection set
(defun build()
(if (/= entity nil) (setq fltrlist (list (eval 'entity))))
(if (and block fltrlist) 
       (setq fltrlist (cons block fltrlist)))
    (if (and (= fltrlist nil) block) (setq fltrlist (list (eval 'block))))
(if (and layer fltrlist)
       (setq fltrlist (cons layer fltrlist)))
    (if (and (= fltrlist nil) layer) (setq fltrlist (list (eval 'layer))))
(action)
)
;what do you want to do with this selection set
(defun action()
(command "textscr")
(repeat 6 (terpri))
;Action menu
(prompt "  What do you want to do with this selection set??\n")
(terpri)
(prompt "             E = Erase\n")
(prompt "             L = Change layer\n")
(prompt "             C = Change color style\n")
(prompt "             CT = Count\n")
(prompt "            XX = Exit and build selection set\n")
(repeat 6 (terpri))
(setq letr (strcase (getstring "\n=======>>Select and Enter Letter: ")))
(if (= letr "E") (command "erase" (ssget "X" fltrlist)))
(if (= letr "L") (command "CHANGE" (ssget "X" fltrlist) "" "P" "LA"))
(if (= letr "C") (command "CHANGE" (ssget "X" fltrlist) "" "p" "c"))
(if (= letr "CT") (progn
       (Prompt "The number of items is: ")
       (princ (sslength (ssget "X" fltrlist)))
       (princ)))
(if (= letr "XX") (ssget "x" fltrlist))
)

;Ends lisp function.
(defun ender ()
(command "graphscr")
(command)
)
;User interface begining menu
(defun menu()
(command "textscr")
(repeat 6 (terpri))
(prompt "                 FILTER  MENU\n")
(terpri)
(prompt "             A = Enter an Entity type\n")
(prompt "             B = Enter a Block name\n")
(prompt "             C = Enter a Layer name\n")
(prompt "             X = Build filter list\n")
(prompt "            XX = Exit filter program\n")
(repeat 7 (terpri))
(setq letr (strcase (getstring "\n=======>>Select and Enter Letter: ")))
  (cond
     ((= letr "A")
	(setq entity (strcase (getstring "\nEnter the Entity type: ")))
        (setq entity (cons 0 (eval entity)))
      (menu))
     ((= letr "B")
	(setq block (strcase (getstring "\nEnter the Block name: ")))
        (setq block (cons 2 (eval block)))
      (menu))
     ((= letr "C")
	(setq layer (strcase (getstring "\nEnter the Layer name: ")))
        (setq layer (cons 8 (eval layer)))
      (menu))
       ((= letr "XX")(ender))
       ((= letr "X")(build))
       ((/= letr nil) (menu))
))(menu))
