(defun C:PTP ( / p0 p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16	;
  p17 p18 p19 p20 p21 p22 p23 p24 p25 p26 p27 p28 p29 p30 p31 p32 p34 t1a	;
  t1b t1c t2a t2b t2c t3a t3b t3c t4a t4b t4c t1 t2 t3 t4 l2 l4 l6 l8 l12	;
  l23 l34 l45 l1a l1b l3a l3b l5a l5b l7a l7b deg1 deg2 deg3 dLp ttot dT dC	;
  dX dY x1i x2i y1i y2i zi di rad blipmode)					;
										;
 (defun *error* (st) (prompt (strcat "error: " st "\007\n")))			;
										;
 (defun tcal (s1 s2 s3 s4)							;
  (setq deg2 0 dLp s1 ttot 0.0 dT 0 dC (/ (* pi V:DIA) 360))			;
  (while (< deg2 90)								;
   (setq deg1 (1+ deg1) deg2 (1+ deg2) deg3 (* pi (/ (float deg2) 180))		;
         dT (+ dT dC))								;
   (if (= s4 1) (setq dX (* rad (cos deg3)) dY (* rad (sin deg3)))		;
                (setq dX (* rad (sin deg3)) dY (* rad (cos deg3))))		;
   (setq sqrt2 (expt (+ (/ V:X1 2) (* V:X2 s2) (- dX)) 2)			;
         sqrt1 (expt (+ (/ V:Y1 2) (* V:Y2 s3) (- dY)) 2)			;
         hyplan (+ sqrt1 sqrt2)							;
         dL (sqrt (+ hyplan (* V:Z V:Z)))					;
         s (/ (+ dL dLp dC) 2)							;	
         r (sqrt (/ (* (- s dL) (- s dLp) (- s dC)) s))				;
         t? (* 2 (atan (/ r (- s dC))))						;
         ttot (+ ttot t?)							;
         dLp (eval dL))								;
   (if (= (rem deg1 15) 0)							;
    (setq ptlist (cons ttot ptlist) ptlist (cons dL ptlist))) 			;
   (prompt (strcat "Evaluate: " (itoa (- 361 deg1)) "  \r")))			;
  (eval ttot))									;
									 	;
(if (not V:X1) (setq V:X1 12.0))						;
 (if (not V:X2) (setq V:X2 0.0))						;
 (if (not V:Y1) (setq V:Y1 12.0))						;
 (if (not V:Y2) (setq V:Y2 0.0))						;
 (if (not V:Z) (setq V:Z 12.0))							;
 (if (not V:DIA) (setq V:DIA 8.0))						;
 (setq x1i (getreal								;
   (strcat "\nEnter X rectangle dimension <" (rtos V:X1) ">: ")))		;
 (if (numberp x1i) (setq V:X1 x1i))						;
 (setq x2i (getreal (strcat "\nEnter X-OFFSET dimension <" (rtos V:X2) ">: ")))	;
 (if (numberp x2i) (setq V:X2 x2i))						;
 (setq y1i (getreal								;
   (strcat "\nEnter Y rectangle dimension <" (rtos V:Y1) ">: ")))		;
 (if (numberp y1i) (setq V:Y1 y1i))						;
 (setq y2i (getreal (strcat "\nEnter Y-OFFSET dimension <" (rtos V:Y2) ">: ")))	;
 (if (numberp y2i) (setq V:Y2 y2i))						;
 (setq zi (getreal (strcat "\nEnter Z dimension <" (rtos V:Z) ">: ")))		;
 (if (numberp zi) (setq V:Z zi))						;
 (setq di (getreal (strcat "\nEnter DIAMETER dimension <" (rtos V:DIA) ">: ")))	;
 (if (numberp di) (setq V:DIA di))						;
 (setq rad (/ V:DIA 2) deg1 0 ptlist (list "ptlist"))				;
										;
 (setq l12 (- (/ V:X1 2) V:X2)							;
       l23 (+ (/ V:X1 2) V:X2)							;
       l34 (+ (/ V:Y1 2) V:Y2)							;
       l45 (- (/ V:Y1 2) V:Y2))							;
 										;
 (setq l2 (sqrt (+ (* V:Z V:Z) (expt (- (+ (/ V:Y1 2) V:Y2) (/ V:DIA 2)) 2)))	;
       l4 (sqrt (+ (* V:Z V:Z) (expt (- (+ (/ V:X1 2) V:X2) (/ V:DIA 2)) 2)))	;
       l6 (sqrt (+ (* V:Z V:Z) (expt (- (/ V:Y1 2) (+ (/ V:DIA 2) V:Y2)) 2)))	;
       l8 (sqrt (+ (* V:Z V:Z) (expt (- (/ V:X1 2) (+ (/ V:DIA 2) V:X2)) 2))))	;
										;
 (setq l1a (sqrt (+ (* l2 l2) (* l12 l12)))					;
       l1b (sqrt (+ (* l8 l8) (* l34 l34)))					;
       l3a (sqrt (+ (* l4 l4) (* l34 l34)))					;
       l3b (sqrt (+ (* l2 l2) (* l23 l23)))					;
       l5a (sqrt (+ (* l6 l6) (* l23 l23)))					;
       l5b (sqrt (+ (* l4 l4) (* l45 l45)))					;
       l7a (sqrt (+ (* l8 l8) (* l45 l45)))					;
       l7b (sqrt (+ (* l6 l6) (* l12 l12))))					;
										;
 (setq t1a (atan l2 l23)							;
       t1b (atan l4 l34)							;
       t1c (tcal l3b 1 1 0)							;
       t2a (atan l4 l45)							;
       t2b (atan l6 l23)							;
       t2c (tcal l5b 1 -1 1)							;
       t3a (atan l6 l12)							;
       t3b (atan l8 l45)							;
       t3c (tcal l7b -1 -1 0)							;
       t4a (atan l8 l34)							;
       t4b (atan l2 l12)							;
       t4c (tcal l1b -1 1 1))							;
                                           					;
 (setq t1 (+ t1a t1b t1c)							;
       t2 (+ t2a t2b t2c)							;
       t3 (+ t3a t3b t3c)							;
       t4 (+ t4a t4b t4c))							;
										;
 (defun PCAL1 (s1 s2 s3 s4)							;
  (polar s1 (- (* s2 pi) s3) s4))						;
										;
 (defun PCAL2 (s1 s2 s3 s4 s5)							;
  (polar s1 (- (* s2 pi) s3 (nth s4 ptlist)) (nth s5 ptlist)))			;
										;
 (setq p0  (list 0 0)								;
       p1 (PCAL1 p0 0 0 l23)							;
       p2 (PCAL1 p1 1 t1 V:Y1)							;
       p3 (PCAL1 p2 2 (+ t1 t2) V:X1)						;
       p4 (PCAL1 p3 3 (+ t1 t2 t3) V:Y1)					;
       p5 (PCAL1 p4 4 (+ t1 t2 t3 t4) l12)					;
       p6 (PCAL1 p4 4 (+ t1 t2 t3 t4a t4c) l1a)					;
       p7 (PCAL1 p3 3 (+ t1 t2 t3a t3c) l7a)					;
       p8 (PCAL1 p2 2 (+ t1 t2a t2c) l5a)					;
       p9 (PCAL1 p1 1 (+ t1a t1c) l3a)						;
       p10 (polar p0 (/ pi 2) l2)						;
       p11 (PCAL2 p1 1 t1a 47 46)						;
       p12 (PCAL2 p1 1 t1a 45 44)						;
       p13 (PCAL2 p1 1 t1a 43 42)						;
       p14 (PCAL2 p1 1 t1a 41 40)						;
       p15 (PCAL2 p1 1 t1a 39 38)						;
       p16 (PCAL2 p1 1 t1a 37 36)						;
       p17 (PCAL2 p2 2 (+ t1 t2a) 35 34)					;
       p18 (PCAL2 p2 2 (+ t1 t2a) 33 32)					;
       p19 (PCAL2 p2 2 (+ t1 t2a) 31 30)					;
       p20 (PCAL2 p2 2 (+ t1 t2a) 29 28)					;
       p21 (PCAL2 p2 2 (+ t1 t2a) 27 26)					;
       p22 (PCAL2 p2 2 (+ t1 t2a) 25 24)					;
       p23 (PCAL2 p3 3 (+ t1 t2 t3a) 23 22)					;
       p24 (PCAL2 p3 3 (+ t1 t2 t3a) 21 20)					;
       p25 (PCAL2 p3 3 (+ t1 t2 t3a) 19 18)					;
       p26 (PCAL2 p3 3 (+ t1 t2 t3a) 17 16)					;
       p27 (PCAL2 p3 3 (+ t1 t2 t3a) 15 14)					;
       p28 (PCAL2 p3 3 (+ t1 t2 t3a) 13 12)					;
       p29 (PCAL2 p4 4 (+ t1 t2 t3 t4a) 11 10)					;
       p30 (PCAL2 p4 4 (+ t1 t2 t3 t4a) 9 8)					;
       p31 (PCAL2 p4 4 (+ t1 t2 t3 t4a) 7 6)					;
       p32 (PCAL2 p4 4 (+ t1 t2 t3 t4a) 5 4)					;
       p33 (PCAL2 p4 4 (+ t1 t2 t3 t4a) 3 2)					;
       p34 (PCAL2 p4 4 (+ t1 t2 t3 t4a) 1 0))					;
										;
 (setvar "cmdecho" 0)								;
 (setq blipmode (getvar "blipmode"))						;
 (setvar "blipmode" 0)								;
 (command ".LINE" p10 p0 p1 p2 p3 p4 p5 p6 p4 p7 p3 p8 p2 p9 p1 p10 "")		;
 (command ".LINE" p12 p1 p14 "")						;
 (command ".LINE" p18 p2 p20 "")						;
 (command ".LINE" p24 p3 p26 "")						;
 (command ".LINE" p30 p4 p32 "")						;
 (command ".PLINE" p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22		;
                  p23 p24 p25 p26 p27 p28 p29 p30 p31 p32 p33 p34 "")		;
 (command ".zoom" "e")								;
 (setvar "limmin" (getvar "extmin"))						;
 (setvar "limmax" (getvar "extmax"))						;
 (command ".pedit" p12 "f" "x")							;
 (setvar "blipmode" blipmode)							;
 (prompt "\nFlat pattern finished\n") (princ))					;
;END OF ROUTINE
